Index: kernel/generic/include/proc/program.h
===================================================================
--- kernel/generic/include/proc/program.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/proc/program.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -55,10 +55,10 @@
 extern void *program_loader;
 
-extern errno_t program_create(as_t *, uintptr_t, char *, program_t *);
-extern errno_t program_create_from_image(void *, char *, program_t *);
-extern errno_t program_create_loader(program_t *, char *);
+extern int program_create(as_t *, uintptr_t, char *, program_t *);
+extern int program_create_from_image(void *, char *, program_t *);
+extern int program_create_loader(program_t *, char *);
 extern void program_ready(program_t *);
 
-extern sys_errno_t sys_program_spawn_loader(char *, size_t);
+extern sysarg_t sys_program_spawn_loader(char *, size_t);
 
 #endif
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/proc/task.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,5 +58,4 @@
 #include <udebug/udebug.h>
 #include <mm/as.h>
-#include <abi/proc/task.h>
 #include <abi/sysinfo.h>
 #include <arch.h>
@@ -157,5 +156,5 @@
 extern void task_release(task_t *);
 extern task_t *task_find_by_id(task_id_t);
-extern errno_t task_kill(task_id_t);
+extern int task_kill(task_id_t);
 extern void task_kill_self(bool) __attribute__((noreturn));
 extern void task_get_accounting(task_t *, uint64_t *, uint64_t *);
@@ -174,5 +173,5 @@
 
 #ifdef __32_BITS__
-extern sys_errno_t sys_task_get_id(sysarg64_t *);
+extern sysarg_t sys_task_get_id(sysarg64_t *);
 #endif
 
@@ -181,7 +180,7 @@
 #endif
 
-extern sys_errno_t sys_task_set_name(const char *, size_t);
-extern sys_errno_t sys_task_kill(task_id_t *);
-extern sys_errno_t sys_task_exit(sysarg_t);
+extern sysarg_t sys_task_set_name(const char *, size_t);
+extern sysarg_t sys_task_kill(task_id_t *);
+extern sysarg_t sys_task_exit(sysarg_t);
 
 #endif
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/proc/thread.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,5 +48,4 @@
 #include <abi/proc/uarg.h>
 #include <udebug/udebug.h>
-#include <abi/proc/thread.h>
 #include <abi/sysinfo.h>
 #include <arch.h>
@@ -256,5 +255,5 @@
 	thread_join_timeout((t), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
 
-extern errno_t thread_join_timeout(thread_t *, uint32_t, unsigned int);
+extern int thread_join_timeout(thread_t *, uint32_t, unsigned int);
 extern void thread_detach(thread_t *);
 
@@ -276,10 +275,10 @@
 
 /* Thread syscall prototypes. */
-extern sys_errno_t sys_thread_create(uspace_arg_t *, char *, size_t,
+extern sysarg_t sys_thread_create(uspace_arg_t *, char *, size_t,
     thread_id_t *);
-extern sys_errno_t sys_thread_exit(int);
-extern sys_errno_t sys_thread_get_id(thread_id_t *);
-extern sys_errno_t sys_thread_usleep(uint32_t);
-extern sys_errno_t sys_thread_udelay(uint32_t);
+extern sysarg_t sys_thread_exit(int);
+extern sysarg_t sys_thread_get_id(thread_id_t *);
+extern sysarg_t sys_thread_usleep(uint32_t);
+extern sysarg_t sys_thread_udelay(uint32_t);
 
 #endif
Index: kernel/generic/include/security/perm.h
===================================================================
--- kernel/generic/include/security/perm.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/security/perm.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -75,6 +75,6 @@
 #ifdef __32_BITS__
 
-extern sys_errno_t sys_perm_grant(sysarg64_t *, perm_t);
-extern sys_errno_t sys_perm_revoke(sysarg64_t *, perm_t);
+extern sysarg_t sys_perm_grant(sysarg64_t *, perm_t);
+extern sysarg_t sys_perm_revoke(sysarg64_t *, perm_t);
 
 #endif  /* __32_BITS__ */
@@ -82,6 +82,6 @@
 #ifdef __64_BITS__
 
-extern sys_errno_t sys_perm_grant(sysarg_t, perm_t);
-extern sys_errno_t sys_perm_revoke(sysarg_t, perm_t);
+extern sysarg_t sys_perm_grant(sysarg_t, perm_t);
+extern sysarg_t sys_perm_revoke(sysarg_t, perm_t);
 
 #endif  /* __64_BITS__ */
Index: kernel/generic/include/str.h
===================================================================
--- kernel/generic/include/str.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/str.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 #include <stddef.h>
 #include <stdint.h>
-#include <errno.h>
 
 /**< Common Unicode characters */
@@ -68,5 +67,5 @@
 
 extern wchar_t str_decode(const char *str, size_t *offset, size_t sz);
-extern errno_t chr_encode(wchar_t ch, char *str, size_t *offset, size_t sz);
+extern int chr_encode(wchar_t ch, char *str, size_t *offset, size_t sz);
 
 extern size_t str_size(const char *str);
@@ -100,11 +99,8 @@
 extern bool wstr_remove(wchar_t *str, size_t pos);
 
-extern errno_t str_uint64_t(const char *, char **, unsigned int, bool, uint64_t *);
+extern int str_uint64_t(const char *, char **, unsigned int, bool, uint64_t *);
 
 extern void order_suffix(const uint64_t, uint64_t *, char *);
 extern void bin_order_suffix(const uint64_t, uint64_t *, const char **, bool);
-
-extern const char *str_error(errno_t err);
-extern const char *str_error_name(errno_t err);
 
 #endif
Index: kernel/generic/include/symtab_lookup.h
===================================================================
--- kernel/generic/include/symtab_lookup.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/symtab_lookup.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,7 +45,7 @@
 };
 
-extern errno_t symtab_name_lookup(uintptr_t, const char **, uintptr_t *);
+extern int symtab_name_lookup(uintptr_t, const char **, uintptr_t *);
 extern const char *symtab_fmt_name_lookup(uintptr_t);
-extern errno_t symtab_addr_lookup(const char *, uintptr_t *);
+extern int symtab_addr_lookup(const char *, uintptr_t *);
 
 #ifdef CONFIG_SYMTAB
Index: kernel/generic/include/synch/condvar.h
===================================================================
--- kernel/generic/include/synch/condvar.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/condvar.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,10 +62,10 @@
 extern void condvar_signal(condvar_t *cv);
 extern void condvar_broadcast(condvar_t *cv);
-extern errno_t _condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec,
+extern int _condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec,
     int flags);
-extern errno_t _condvar_wait_timeout_spinlock_impl(condvar_t *cv, spinlock_t *lock,
-    uint32_t usec, int flags);
-extern errno_t _condvar_wait_timeout_irq_spinlock(condvar_t *cv,
-    irq_spinlock_t *irq_lock, uint32_t usec, int flags);
+extern int _condvar_wait_timeout_spinlock_impl(condvar_t *cv, spinlock_t *lock, 
+	uint32_t usec, int flags);
+extern int _condvar_wait_timeout_irq_spinlock(condvar_t *cv, 
+	irq_spinlock_t *irq_lock, uint32_t usec, int flags);
 
 
Index: kernel/generic/include/synch/futex.h
===================================================================
--- kernel/generic/include/synch/futex.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/futex.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,6 +53,6 @@
 
 extern void futex_init(void);
-extern sys_errno_t sys_futex_sleep(uintptr_t);
-extern sys_errno_t sys_futex_wakeup(uintptr_t);
+extern sysarg_t sys_futex_sleep(uintptr_t);
+extern sysarg_t sys_futex_wakeup(uintptr_t);
 
 extern void futex_task_cleanup(void);
Index: kernel/generic/include/synch/mutex.h
===================================================================
--- kernel/generic/include/synch/mutex.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/mutex.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -67,5 +67,5 @@
 extern void mutex_initialize(mutex_t *, mutex_type_t);
 extern bool mutex_locked(mutex_t *);
-extern errno_t _mutex_lock_timeout(mutex_t *, uint32_t, unsigned int);
+extern int _mutex_lock_timeout(mutex_t *, uint32_t, unsigned int);
 extern void mutex_unlock(mutex_t *);
 
Index: kernel/generic/include/synch/semaphore.h
===================================================================
--- kernel/generic/include/synch/semaphore.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/semaphore.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define KERN_SEMAPHORE_H_
 
-#include <errno.h>
 #include <stdint.h>
 #include <synch/waitq.h>
@@ -55,9 +54,9 @@
 
 #define semaphore_down_interruptable(s) \
-	(_semaphore_down_timeout((s), SYNCH_NO_TIMEOUT, \
-		SYNCH_FLAGS_INTERRUPTIBLE) != EINTR)
+	(ESYNCH_INTERRUPTED != _semaphore_down_timeout((s), SYNCH_NO_TIMEOUT, \
+		SYNCH_FLAGS_INTERRUPTIBLE))
 
 extern void semaphore_initialize(semaphore_t *, int);
-extern errno_t _semaphore_down_timeout(semaphore_t *, uint32_t, unsigned int);
+extern int _semaphore_down_timeout(semaphore_t *, uint32_t, unsigned int);
 extern void semaphore_up(semaphore_t *);
 extern int semaphore_count_get(semaphore_t *);
Index: kernel/generic/include/synch/smc.h
===================================================================
--- kernel/generic/include/synch/smc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/smc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,5 @@
 #define KERN_SMC_H_
 
-extern sys_errno_t sys_smc_coherence(uintptr_t, size_t);
+extern sysarg_t sys_smc_coherence(uintptr_t, size_t);
 
 #endif
Index: kernel/generic/include/synch/smp_memory_barrier.h
===================================================================
--- kernel/generic/include/synch/smp_memory_barrier.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/smp_memory_barrier.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <typedefs.h>
 
-extern sys_errno_t sys_smp_memory_barrier(void);
+extern sysarg_t sys_smp_memory_barrier(void);
 
 #endif
Index: kernel/generic/include/synch/spinlock.h
===================================================================
--- kernel/generic/include/synch/spinlock.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/spinlock.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -112,5 +112,5 @@
 
 extern void spinlock_initialize(spinlock_t *, const char *);
-extern bool spinlock_trylock(spinlock_t *);
+extern int spinlock_trylock(spinlock_t *);
 extern void spinlock_lock_debug(spinlock_t *);
 extern void spinlock_unlock_debug(spinlock_t *);
@@ -287,5 +287,5 @@
 extern void irq_spinlock_lock(irq_spinlock_t *, bool);
 extern void irq_spinlock_unlock(irq_spinlock_t *, bool);
-extern bool irq_spinlock_trylock(irq_spinlock_t *);
+extern int irq_spinlock_trylock(irq_spinlock_t *);
 extern void irq_spinlock_pass(irq_spinlock_t *, irq_spinlock_t *);
 extern void irq_spinlock_exchange(irq_spinlock_t *, irq_spinlock_t *);
Index: kernel/generic/include/synch/waitq.h
===================================================================
--- kernel/generic/include/synch/waitq.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/waitq.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -67,13 +67,13 @@
 
 #define waitq_sleep(wq) \
-	waitq_sleep_timeout((wq), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE, NULL)
+	waitq_sleep_timeout((wq), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
 
 struct thread;
 
 extern void waitq_initialize(waitq_t *);
-extern errno_t waitq_sleep_timeout(waitq_t *, uint32_t, unsigned int, bool *);
+extern int waitq_sleep_timeout(waitq_t *, uint32_t, unsigned int);
 extern ipl_t waitq_sleep_prepare(waitq_t *);
-extern errno_t waitq_sleep_timeout_unsafe(waitq_t *, uint32_t, unsigned int, bool *);
-extern void waitq_sleep_finish(waitq_t *, bool, ipl_t);
+extern int waitq_sleep_timeout_unsafe(waitq_t *, uint32_t, unsigned int);
+extern void waitq_sleep_finish(waitq_t *, int, ipl_t);
 extern void waitq_wakeup(waitq_t *, wakeup_mode_t);
 extern void _waitq_wakeup_unsafe(waitq_t *, wakeup_mode_t);
Index: kernel/generic/include/synch/workqueue.h
===================================================================
--- kernel/generic/include/synch/workqueue.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/synch/workqueue.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,13 +61,13 @@
 extern void workq_global_worker_init(void);
 extern void workq_global_stop(void);
-extern bool workq_global_enqueue_noblock(work_t *, work_func_t);
-extern bool workq_global_enqueue(work_t *, work_func_t);
+extern int workq_global_enqueue_noblock(work_t *, work_func_t);
+extern int workq_global_enqueue(work_t *, work_func_t);
 
-extern struct work_queue *workq_create(const char *);
+extern struct work_queue * workq_create(const char *);
 extern void workq_destroy(struct work_queue *);
-extern bool workq_init(struct work_queue *, const char *);
+extern int workq_init(struct work_queue *, const char *);
 extern void workq_stop(struct work_queue *);
-extern bool workq_enqueue_noblock(struct work_queue *, work_t *, work_func_t);
-extern bool workq_enqueue(struct work_queue *, work_t *, work_func_t);
+extern int workq_enqueue_noblock(struct work_queue *, work_t *, work_func_t);
+extern int workq_enqueue(struct work_queue *, work_t *, work_func_t);
 
 extern void workq_print_info(struct work_queue *);
Index: kernel/generic/include/syscall/copy.h
===================================================================
--- kernel/generic/include/syscall/copy.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/syscall/copy.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,12 +44,12 @@
 extern char memcpy_to_uspace_failover_address;
 
-extern errno_t copy_from_uspace(void *dst, const void *uspace_src, size_t size);
-extern errno_t copy_to_uspace(void *dst_uspace, const void *src, size_t size);
+extern int copy_from_uspace(void *dst, const void *uspace_src, size_t size);
+extern int copy_to_uspace(void *dst_uspace, const void *src, size_t size);
 
 /*
  * This interface must be implemented by each architecture.
  */
-extern errno_t memcpy_from_uspace(void *dst, const void *uspace_src, size_t size);
-extern errno_t memcpy_to_uspace(void *uspace_dst, const void *src, size_t size);
+extern int memcpy_from_uspace(void *dst, const void *uspace_src, size_t size);
+extern int memcpy_to_uspace(void *uspace_dst, const void *src, size_t size);
 
 #endif
Index: kernel/generic/include/sysinfo/sysinfo.h
===================================================================
--- kernel/generic/include/sysinfo/sysinfo.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/sysinfo/sysinfo.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -162,10 +162,10 @@
 extern void sysinfo_dump(sysinfo_item_t *);
 
-extern sys_errno_t sys_sysinfo_get_keys_size(void *, size_t, void *);
-extern sys_errno_t sys_sysinfo_get_keys(void *, size_t, void *, size_t, size_t *);
+extern sysarg_t sys_sysinfo_get_keys_size(void *, size_t, void *);
+extern sysarg_t sys_sysinfo_get_keys(void *, size_t, void *, size_t, size_t *);
 extern sysarg_t sys_sysinfo_get_val_type(void *, size_t);
-extern sys_errno_t sys_sysinfo_get_value(void *, size_t, void *);
-extern sys_errno_t sys_sysinfo_get_data_size(void *, size_t, void *);
-extern sys_errno_t sys_sysinfo_get_data(void *, size_t, void *, size_t, size_t *);
+extern sysarg_t sys_sysinfo_get_value(void *, size_t, void *);
+extern sysarg_t sys_sysinfo_get_data_size(void *, size_t, void *);
+extern sysarg_t sys_sysinfo_get_data(void *, size_t, void *, size_t, size_t *);
 
 #endif
Index: kernel/generic/include/typedefs.h
===================================================================
--- kernel/generic/include/typedefs.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/typedefs.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <_bits/errno.h>
 
 typedef struct {
@@ -43,5 +42,5 @@
 } atomic_t;
 
-typedef void (*function)(void);
+typedef void (* function)(void);
 
 typedef uint32_t container_id_t;
Index: kernel/generic/include/udebug/udebug.h
===================================================================
--- kernel/generic/include/udebug/udebug.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/udebug/udebug.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -102,5 +102,5 @@
 void udebug_before_thread_runs(void);
 
-errno_t udebug_task_cleanup(struct task *);
+int udebug_task_cleanup(struct task *);
 void udebug_thread_fault(void);
 
Index: kernel/generic/include/udebug/udebug_ipc.h
===================================================================
--- kernel/generic/include/udebug/udebug_ipc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/udebug/udebug_ipc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <ipc/ipc.h>
 
-errno_t udebug_request_preprocess(call_t *call, phone_t *phone);
+int udebug_request_preprocess(call_t *call, phone_t *phone);
 void udebug_call_receive(call_t *call);
 
Index: kernel/generic/include/udebug/udebug_ops.h
===================================================================
--- kernel/generic/include/udebug/udebug_ops.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/udebug/udebug_ops.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,23 +37,20 @@
 
 #include <ipc/ipc.h>
-#include <proc/thread.h>
-#include <stdbool.h>
-#include <stddef.h>
 
-errno_t udebug_begin(call_t *call, bool *active);
-errno_t udebug_end(void);
-errno_t udebug_set_evmask(udebug_evmask_t mask);
+int udebug_begin(call_t *call);
+int udebug_end(void);
+int udebug_set_evmask(udebug_evmask_t mask);
 
-errno_t udebug_go(thread_t *t, call_t *call);
-errno_t udebug_stop(thread_t *t, call_t *call);
+int udebug_go(thread_t *t, call_t *call);
+int udebug_stop(thread_t *t, call_t *call);
 
-errno_t udebug_thread_read(void **buffer, size_t buf_size, size_t *stored,
+int udebug_thread_read(void **buffer, size_t buf_size, size_t *stored,
     size_t *needed);
-errno_t udebug_name_read(char **data, size_t *data_size);
-errno_t udebug_args_read(thread_t *t, void **buffer);
+int udebug_name_read(char **data, size_t *data_size);
+int udebug_args_read(thread_t *t, void **buffer);
 
-errno_t udebug_regs_read(thread_t *t, void **buffer);
+int udebug_regs_read(thread_t *t, void **buffer);
 
-errno_t udebug_mem_read(sysarg_t uspace_addr, size_t n, void **buffer);
+int udebug_mem_read(sysarg_t uspace_addr, size_t n, void **buffer);
 
 #endif
Index: kernel/generic/src/adt/bitmap.c
===================================================================
--- kernel/generic/src/adt/bitmap.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/adt/bitmap.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -269,5 +269,5 @@
  *
  */
-bool bitmap_allocate_range(bitmap_t *bitmap, size_t count, size_t base,
+int bitmap_allocate_range(bitmap_t *bitmap, size_t count, size_t base,
     size_t prefered, size_t constraint, size_t *index)
 {
Index: kernel/generic/src/cap/cap.c
===================================================================
--- kernel/generic/src/cap/cap.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/cap/cap.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -124,5 +124,5 @@
  * @param task  Task for which to allocate the info structure.
  */
-errno_t caps_task_alloc(task_t *task)
+int caps_task_alloc(task_t *task)
 {
 	task->cap_info = (cap_info_t *) malloc(sizeof(cap_info_t),
@@ -257,11 +257,11 @@
  * @param task  Task for which to allocate the new capability.
  *
- * @param[out] handle  New capability handle on success.
- *
- * @return An error code in case of error.
- */
-errno_t cap_alloc(task_t *task, cap_handle_t *handle)
+ * @return New capability handle on success.
+ * @return Negative error code in case of error.
+ */
+cap_handle_t cap_alloc(task_t *task)
 {
 	cap_t *cap = NULL;
+	cap_handle_t handle;
 
 	/*
@@ -293,8 +293,8 @@
 
 	cap->state = CAP_STATE_ALLOCATED;
-	*handle = cap->handle;
-	mutex_unlock(&task->cap_info->lock);
-
-	return EOK;
+	handle = cap->handle;
+	mutex_unlock(&task->cap_info->lock);
+
+	return handle;
 }
 
Index: kernel/generic/src/console/chardev.c
===================================================================
--- kernel/generic/src/console/chardev.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/console/chardev.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include <synch/spinlock.h>
 #include <print.h>
-#include <halt.h>
+#include <func.h>
 #include <cpu.h>
 
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/console/cmd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,5 +52,5 @@
 #include <arch.h>
 #include <config.h>
-#include <halt.h>
+#include <func.h>
 #include <str.h>
 #include <macros.h>
@@ -972,5 +972,5 @@
 	sysarg_t (*fnc)(void);
 	fncptr_t fptr;
-	errno_t rc;
+	int rc;
 
 	symbol = (char *) argv->buffer;
@@ -1033,5 +1033,5 @@
 	sysarg_t arg1 = argv[1].intval;
 	fncptr_t fptr;
-	errno_t rc;
+	int rc;
 
 	symbol = (char *) argv->buffer;
@@ -1070,5 +1070,5 @@
 	sysarg_t arg2 = argv[2].intval;
 	fncptr_t fptr;
-	errno_t rc;
+	int rc;
 
 	symbol = (char *) argv->buffer;
@@ -1107,5 +1107,5 @@
 	sysarg_t arg3 = argv[3].intval;
 	fncptr_t fptr;
-	errno_t rc;
+	int rc;
 	
 	symbol = (char *) argv->buffer;
@@ -1182,5 +1182,5 @@
 	uint32_t arg1 = argv[1].intval;
 	bool pointer = false;
-	errno_t rc;
+	int rc;
 	
 	if (((char *) argv->buffer)[0] == '*') {
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/console/console.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -391,8 +391,8 @@
  *
  */
-sys_errno_t sys_kio(int cmd, const void *buf, size_t size)
+sysarg_t sys_kio(int cmd, const void *buf, size_t size)
 {
 	char *data;
-	errno_t rc;
+	int rc;
 
 	switch (cmd) {
@@ -408,15 +408,15 @@
 
 	if (size > PAGE_SIZE)
-		return (sys_errno_t) ELIMIT;
+		return (sysarg_t) ELIMIT;
 	
 	if (size > 0) {
 		data = (char *) malloc(size + 1, 0);
 		if (!data)
-			return (sys_errno_t) ENOMEM;
+			return (sysarg_t) ENOMEM;
 		
 		rc = copy_from_uspace(data, buf, size);
 		if (rc) {
 			free(data);
-			return (sys_errno_t) rc;
+			return (sysarg_t) rc;
 		}
 		data[size] = 0;
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/console/kconsole.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,5 +52,5 @@
 #include <macros.h>
 #include <debug.h>
-#include <halt.h>
+#include <func.h>
 #include <str.h>
 #include <sysinfo/sysinfo.h>
@@ -563,5 +563,5 @@
 		
 		uintptr_t symaddr;
-		errno_t rc = symtab_addr_lookup(symname, &symaddr);
+		int rc = symtab_addr_lookup(symname, &symaddr);
 		switch (rc) {
 		case ENOENT:
@@ -591,5 +591,5 @@
 		uint64_t value;
 		char *end;
-		errno_t rc = str_uint64_t(text, &end, 0, false, &value);
+		int rc = str_uint64_t(text, &end, 0, false, &value);
 		if (end != text + len)
 			rc = EINVAL;
Index: kernel/generic/src/ddi/ddi.c
===================================================================
--- kernel/generic/src/ddi/ddi.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ddi/ddi.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -104,5 +104,5 @@
  *
  */
-NO_TRACE static errno_t physmem_map(uintptr_t phys, size_t pages,
+NO_TRACE static int physmem_map(uintptr_t phys, size_t pages,
     unsigned int flags, uintptr_t *virt, uintptr_t bound)
 {
@@ -210,5 +210,5 @@
 }
 
-NO_TRACE static errno_t physmem_unmap(uintptr_t virt)
+NO_TRACE static int physmem_unmap(uintptr_t virt)
 {
 	assert(TASK);
@@ -228,9 +228,9 @@
  *
  */
-sys_errno_t sys_physmem_map(uintptr_t phys, size_t pages, unsigned int flags,
+sysarg_t sys_physmem_map(uintptr_t phys, size_t pages, unsigned int flags,
     void *virt_ptr, uintptr_t bound)
 {
 	uintptr_t virt;
-	errno_t rc = copy_from_uspace(&virt, virt_ptr, sizeof(virt));
+	int rc = copy_from_uspace(&virt, virt_ptr, sizeof(virt));
 	if (rc != EOK)
 		return rc;
@@ -250,5 +250,5 @@
 }
 
-sys_errno_t sys_physmem_unmap(uintptr_t virt)
+sysarg_t sys_physmem_unmap(uintptr_t virt)
 {
 	return physmem_unmap(virt);
@@ -265,5 +265,5 @@
  *
  */
-NO_TRACE static errno_t iospace_enable(task_id_t id, uintptr_t ioaddr, size_t size)
+NO_TRACE static int iospace_enable(task_id_t id, uintptr_t ioaddr, size_t size)
 {
 	/*
@@ -290,5 +290,5 @@
 	/* Lock the task and release the lock protecting tasks_btree. */
 	irq_spinlock_exchange(&tasks_lock, &task->lock);
-	errno_t rc = ddi_iospace_enable_arch(task, ioaddr, size);
+	int rc = ddi_iospace_enable_arch(task, ioaddr, size);
 	irq_spinlock_unlock(&task->lock, true);
 
@@ -306,5 +306,5 @@
  *
  */
-NO_TRACE static errno_t iospace_disable(task_id_t id, uintptr_t ioaddr, size_t size)
+NO_TRACE static int iospace_disable(task_id_t id, uintptr_t ioaddr, size_t size)
 {
 	/*
@@ -331,5 +331,5 @@
 	/* Lock the task and release the lock protecting tasks_btree. */
 	irq_spinlock_exchange(&tasks_lock, &task->lock);
-	errno_t rc = ddi_iospace_disable_arch(task, ioaddr, size);
+	int rc = ddi_iospace_disable_arch(task, ioaddr, size);
 	irq_spinlock_unlock(&task->lock, true);
 	
@@ -344,27 +344,27 @@
  *
  */
-sys_errno_t sys_iospace_enable(ddi_ioarg_t *uspace_io_arg)
+sysarg_t sys_iospace_enable(ddi_ioarg_t *uspace_io_arg)
 {
 	ddi_ioarg_t arg;
-	errno_t rc = copy_from_uspace(&arg, uspace_io_arg, sizeof(ddi_ioarg_t));
-	if (rc != EOK)
-		return (sys_errno_t) rc;
-	
-	return (sys_errno_t) iospace_enable((task_id_t) arg.task_id,
+	int rc = copy_from_uspace(&arg, uspace_io_arg, sizeof(ddi_ioarg_t));
+	if (rc != 0)
+		return (sysarg_t) rc;
+	
+	return (sysarg_t) iospace_enable((task_id_t) arg.task_id,
 	    (uintptr_t) arg.ioaddr, (size_t) arg.size);
 }
 
-sys_errno_t sys_iospace_disable(ddi_ioarg_t *uspace_io_arg)
+sysarg_t sys_iospace_disable(ddi_ioarg_t *uspace_io_arg)
 {
 	ddi_ioarg_t arg;
-	errno_t rc = copy_from_uspace(&arg, uspace_io_arg, sizeof(ddi_ioarg_t));
-	if (rc != EOK)
-		return (sys_errno_t) rc;
-
-	return (sys_errno_t) iospace_disable((task_id_t) arg.task_id,
+	int rc = copy_from_uspace(&arg, uspace_io_arg, sizeof(ddi_ioarg_t));
+	if (rc != 0)
+		return (sysarg_t) rc;
+
+	return (sysarg_t) iospace_disable((task_id_t) arg.task_id,
 	    (uintptr_t) arg.ioaddr, (size_t) arg.size);
 }
 
-NO_TRACE static errno_t dmamem_map(uintptr_t virt, size_t size, unsigned int map_flags,
+NO_TRACE static int dmamem_map(uintptr_t virt, size_t size, unsigned int map_flags,
     unsigned int flags, uintptr_t *phys)
 {
@@ -375,5 +375,5 @@
 }
 
-NO_TRACE static errno_t dmamem_map_anonymous(size_t size, uintptr_t constraint,
+NO_TRACE static int dmamem_map_anonymous(size_t size, uintptr_t constraint,
     unsigned int map_flags, unsigned int flags, uintptr_t *phys,
     uintptr_t *virt, uintptr_t bound)
@@ -403,5 +403,5 @@
 }
 
-NO_TRACE static errno_t dmamem_unmap(uintptr_t virt, size_t size)
+NO_TRACE static int dmamem_unmap(uintptr_t virt, size_t size)
 {
 	// TODO: implement unlocking & unmap
@@ -409,10 +409,10 @@
 }
 
-NO_TRACE static errno_t dmamem_unmap_anonymous(uintptr_t virt)
+NO_TRACE static int dmamem_unmap_anonymous(uintptr_t virt)
 {
 	return as_area_destroy(TASK->as, virt);
 }
 
-sys_errno_t sys_dmamem_map(size_t size, unsigned int map_flags, unsigned int flags,
+sysarg_t sys_dmamem_map(size_t size, unsigned int map_flags, unsigned int flags,
     void *phys_ptr, void *virt_ptr, uintptr_t bound)
 {
@@ -423,5 +423,5 @@
 		
 		uintptr_t phys;
-		errno_t rc = dmamem_map((uintptr_t) virt_ptr, size, map_flags,
+		int rc = dmamem_map((uintptr_t) virt_ptr, size, map_flags,
 		    flags, &phys);
 		
@@ -440,5 +440,5 @@
 		
 		uintptr_t constraint;
-		errno_t rc = copy_from_uspace(&constraint, phys_ptr,
+		int rc = copy_from_uspace(&constraint, phys_ptr,
 		    sizeof(constraint));
 		if (rc != EOK)
@@ -472,5 +472,5 @@
 }
 
-sys_errno_t sys_dmamem_unmap(uintptr_t virt, size_t size, unsigned int flags)
+sysarg_t sys_dmamem_unmap(uintptr_t virt, size_t size, unsigned int flags)
 {
 	if ((flags & DMAMEM_FLAGS_ANONYMOUS) == 0)
Index: kernel/generic/src/debug/panic.c
===================================================================
--- kernel/generic/src/debug/panic.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/debug/panic.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,5 @@
 #include <print.h>
 #include <stacktrace.h>
-#include <halt.h>
+#include <func.h>
 #include <typedefs.h>
 #include <mm/as.h>
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/debug/symtab.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,9 +50,9 @@
  * @param offset Place to store offset from the symbol address.
  *
- * @return Zero on success or an error code, ENOENT if not found,
+ * @return Zero on success or negative error code, ENOENT if not found,
  *         ENOTSUP if symbol table not available.
  *
  */
-errno_t symtab_name_lookup(uintptr_t addr, const char **name, uintptr_t *offset)
+int symtab_name_lookup(uintptr_t addr, const char **name, uintptr_t *offset)
 {
 #ifdef CONFIG_SYMTAB
@@ -96,5 +96,5 @@
 {
 	const char *name;
-	errno_t rc = symtab_name_lookup(addr, &name, NULL);
+	int rc = symtab_name_lookup(addr, &name, NULL);
 	
 	switch (rc) {
@@ -156,5 +156,5 @@
  *
  */
-errno_t symtab_addr_lookup(const char *name, uintptr_t *addr)
+int symtab_addr_lookup(const char *name, uintptr_t *addr)
 {
 #ifdef CONFIG_SYMTAB
